import { API, Checksum256Type, Checksum256, NameType, PermissionLevelType } from '@wharfkit/antelope';
import { ActionData, Signer } from '../eosio/transaction';
export declare class EosioMsigContract {
    static singletonInstance: EosioMsigContract;
    contractName: string;
    static get Instance(): EosioMsigContract;
    constructor(contractName?: string);
    propose(proposer: NameType, proposalName: NameType, requested: PermissionLevelType[], actions: ActionData[], signer: Signer): Promise<{
        transaction: API.v1.PushTransactionResponse;
        proposalHash: Checksum256;
    }>;
    approve(proposer: NameType, proposalName: NameType, approver: NameType, proposalHash: undefined | Checksum256Type, signer: Signer): Promise<API.v1.PushTransactionResponse>;
    exec(proposer: NameType, proposalName: NameType, executer: NameType, signer: Signer): Promise<API.v1.PushTransactionResponse>;
    cancel(proposer: NameType, proposalName: NameType, canceler: NameType, signer: Signer): Promise<API.v1.PushTransactionResponse>;
}
//# sourceMappingURL=EosioMsigContract.d.ts.map